#include<unistd.h>
#include<sys/types.h>
#include<sys/wait.h>

void dofork(int n){
  pid_t chpid;
  
  printf("%d:%d\n",getpid(),n);
  chpid=fork();
  if (chpid < 0){
    printf("can't fork anymore\n");
    exit(-21);
  }
  if (chpid>0)
    waitpid(chpid,0,0);
  else if (n) dofork(--n);
}

int main(int argc, char*argv[]){
  int nmp;
  sscanf(argv[1],"%d",&nmp);

  dofork(nmp);
  return 0;

}
