#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<time.h>

void merror(const char *s, int i){
 printf("%s:%d\n",s,i);
 exit(-1);
}

pthread_attr_t attr;

int total, loopmax;

void* athread(void *arg){
 int i= *((int*) arg)+1;
 int id = i;
 int j;

  for (j=0;j<loopmax;j++)
   printf("my id:%d:%d\n",id,pthread_self());
/*  printf("exiting %d\n",id); */
 pthread_exit(&total);
}

 

int main(int argc, char **argv){
 int i=0;
 pthread_t pt[10];
 struct timeval t0,t1;
 struct timezone tz0,tz1;


 pthread_attr_setschedpolicy(&attr,SCHED_RR);
 
 sscanf(argv[1],"%d",&total);
 sscanf(argv[2],"%d",&loopmax);

 gettimeofday(&t0,&tz0);

 for (i=0;i<total;i++)
  pthread_create(&pt[i],&attr,&athread,&i);
 for (i=0;i<total;i++)
  pthread_join(pt[i],NULL);
 gettimeofday(&t1,&tz1);


 sleep(2);

 printf("Total time:%ld:%ld:%ld\n",
           (long) t0.tv_sec*1000000+t0.tv_usec,
           (long) t1.tv_sec*1000000+t1.tv_usec,
           ((long) t1.tv_sec*1000000+t1.tv_usec)-
           ((long) t0.tv_sec*1000000+t0.tv_usec));

 exit(0);


}

