#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<unistd.h>

#define FILE "teste"
#define B 512
#define N B*1

void storevec(int v[],int n){
  int fd = creat(FILE,0666);
  write(fd,v,N*sizeof(int));
  close(fd);
}

void updatevec(int n){
  int fd = open(FILE,O_RDWR);
  int i;
  for (i=0;i<10;i++){
    int pos=lrand48() % n;
    int aux;
    lseek(fd,pos*sizeof(int),SEEK_SET);
    read(fd,&aux,sizeof(int));
    aux++;
    lseek(fd,pos*sizeof(int),SEEK_SET);
    write(fd,&aux,sizeof(int));
  }
  close(fd);
}

void retrievevec(int v[], int n){
  int fd = open(FILE,O_RDONLY);
  int i;
  for(i=0;i<n;i+=(B/16))
   read(fd,v,(B/16)*sizeof(int));
  close(fd);
}

int printvec(int v[], int n){
  int i;
  for (i=0;i<n;i++) printf("%d\n",v[i]);
}

int main(){
  int v[N],i;
  
  for (i=0;i<N;i++) v[i]=lrand48();

  storevec(v,N);
  updatevec(N);
  retrievevec(v,N);
  printvec(v,N);
}
  
