//
// Laboratory for Scientific Computing
// http://www.lam-mpi.org/tutorials/
// University of Notre Dame
//
// MPI Tutorial
// Lab 1: Hello world 
//
// Mail questions regarding tutorial material to mpi@lam-mpi.org
//

#include <iostream.h>
#include "mpi++.h"


int main(int argc, char *argv[])
{
  int rank, size;

  MPI::Init(argc, argv);

  rank = MPI::COMM_WORLD.Get_rank();
  size = MPI::COMM_WORLD.Get_size();

  cout << "Hello world! I am " << rank << " of " << size << endl;

  MPI::Finalize();

  return 0;
}

