#include<sys/types.h>
#include<sys/socket.h>
#include<sys/un.h>
#include<netinet/in.h>
#include<arpa/inet.h>
#include<stdio.h>

#define MSG "A message"

void error(char *s){
  printf("%s\n", s);
  exit(1);
}

int main(int argc,char **argv){
  int sfd;
  struct sockaddr_in serv;

  if ( (sfd=socket(PF_INET,SOCK_STREAM,0)) < 0)
   error("socket creation\n");
  serv.sin_family=PF_INET;
  serv.sin_port=htons(2049);

  if (inet_pton(PF_INET,argv[1],&serv.sin_addr)<=0)
    error(argv[1]);
  if (connect(sfd,(struct sockaddr*) &serv,sizeof(serv)) < 0)
    error("connect");
  if (write(sfd,MSG,sizeof(MSG)) != sizeof(MSG))
    error("write");
  return 0;
}


