#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define max(x,y) (x<y?y:x)



it
main(int argc, char *argv[])
{
  int rank,size;
  it v,oldv,j,*vec;
  MPI_Status st;

  MPI_Init(&argc, &argv);
  oldv=v = rand();
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  vec=(int *) malloc(size*sizeof(int));
  if (rank==0)
	for (j=0;j<size;j++)  vec[j]=rand()%size;
  MPI_Scatter(vec,1,MPI_INT,&v,1,MPI_INT,0,MPI_COMM_WORLD);

	
  oldv=v;
  printf("start:%d:%d\n",rank,v);
  if (rank<size-1){
	  MPI_Send(&v,1,MPI_INT,rank+1,1,MPI_COMM_WORLD);
  }

  for (j=1;j<size;j*=2){
 	int l;

	printf("%d:%d:%d\n",rank,j,v);

	if (rank-j>=0){
		MPI_Recv(&l,1,MPI_INT,rank-j,1,MPI_COMM_WORLD,&st);
                v=max(v,l);
	}
	if (j+rank<size)
		MPI_Send(&v,1,MPI_INT,rank+j,1,MPI_COMM_WORLD);
  }
  printf("rank %d:oldv %d:max %d\n",rank,oldv,v);


  MPI_Finalize();
}


 

